.386
.model flat,stdcall
option casemap:none

include filefunc.inc

PUBLIC  WriteFileToDisc@12

.code

;   WriteFileToDisc PROC pFileName:DWORD,pMemory:DWORD,nSize:DWORD

;   pFileName       :   pointer to file name
;   pMemory         :   address of data block to write to disc
;   nSize           :   number of bytes to write

;   Return values   :   if the function succeeds, eax is 2
;                   :   if the function fails, eax is 1,0 or -1
;                       depending on the situation


WriteFileToDisc@12:

    sub     esp,2*4                 ; reserve 8 bytes for local variables
    push    edi
    invoke  CreateFile,DWORD PTR [esp+40],GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit
@@:
    mov     DWORD PTR [esp+8],eax   ; save the file handle
    lea     edx,DWORD PTR [esp+4]
    invoke  WriteFile,eax,DWORD PTR [esp+32],DWORD PTR [esp+32],edx,0
    test    eax,eax
    jz      _exit
@@:    
    invoke  CloseHandle,DWORD PTR [esp+8]
    test    eax,eax
    jnz     @f
    mov     eax,CLOSE_HANDLE_ERROR
    jmp     _exit
@@:
    mov     eax,WRITE_FILE_SUCCESS

_exit:

    pop     edi
    add     esp,2*4                 ; balance the stack
    ret     3*4

;   ENDP WriteFileToDisc

END

