; SaveDesktop V1.1 by Vortex
; Tiny tool to save the desktop image to a BMP file
; Usage : SaveDesktop bitmapname.bmp

.386
.model flat,stdcall
option casemap:none

include SaveDesktop.inc

.data
IID_IPicture  GUID <7BF80980h,0BF32h,101Ah,<8Bh,0BBh,00h,0AAh,00h,30h,0Ch,0ABh>>

.data?
buffer        db 512 dup(?)

.code

start:

    call    main
    invoke  ExitProcess,0

main PROC uses esi

LOCAL pBitmap   :DWORD
LOCAL hGlobal   :DWORD
LOCAL pStream   :DWORD
LOCAL pcbSize   :DWORD
LOCAL hBmp      :DWORD
LOCAL hDC       :DWORD
LOCAL tempDC    :DWORD
LOCAL x         :DWORD
LOCAL y         :DWORD
LOCAL hOldBmp   :DWORD
LOCAL pd        :PICTDESC
LOCAL bm        :BITMAP

    lea     esi,[buffer]
    invoke  ParseCmdLine,esi
    cmp     eax,2
    je      @f
    ret
@@:
    invoke  GetDC,0                                 ; get the DC of desktop
    mov     hDC,eax
    invoke  CreateCompatibleDC,eax                  ; create a DC compatible with hDC
    mov     tempDC,eax
    invoke  GetSystemMetrics,SM_CXSCREEN            ; get the width and height of the screen
    mov     x,eax
    invoke  GetSystemMetrics,SM_CYSCREEN
    mov     y,eax
    invoke  CreateCompatibleBitmap,hDC,x,eax        ; create a compatible bitmap
    mov     hBmp,eax
    invoke  SelectObject,tempDC,eax
    mov     hOldBmp,eax
    invoke  BitBlt,tempDC,0,0,x,y,hDC,0,0,SRCCOPY   ; copy the screen to the target DC
    invoke  SelectObject,tempDC,hOldBmp             ; return back the old handle
    mov     pd.cbSizeofstruct,SIZEOF PICTDESC       ; initialize the PICTDESC structure
    mov     pd.picType,PICTYPE_BITMAP
    push    hBmp
    pop     pd.bmp.hbitmap
    mov     pd.bmp.hpal,0
    lea     edx,[pBitmap]
    invoke  OleCreatePictureIndirect,ADDR pd,ADDR IID_IPicture,TRUE,edx
                                                    ; create the OLE image
    invoke  CreateStreamOnHGlobal,NULL,TRUE,ADDR pStream
                                                    ; create the destination stream to save the image
    lea     eax,[pcbSize]
    push    eax
    push    TRUE
    push    pStream
    mov     eax,pBitmap
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IPicture.SaveAsFile[eax]                ; save the image to the stream
    invoke  GetHGlobalFromStream,pStream,ADDR hGlobal
    invoke  GlobalLock,hGlobal                      ; get the address pointing the image in memory
    invoke  WriteFileToDisc,DWORD PTR [esi+4],eax,pcbSize
                                                    ; write the image to disc
    mov     eax,pBitmap                             ; release pBitmap
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IPicture.Release[eax]

    mov     eax,pStream
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IStream.Release[eax]                    ; release the stream and hGlobal

    invoke  DeleteObject,hBmp                       ; return back resources to the OS
    invoke  DeleteDC,tempDC
    invoke  ReleaseDC,0,hDC
    ret
    
main ENDP

END start

